check-lxdialog.sh 1.8 KB
Newer Older
1 2 3 4 5 6
#!/bin/sh
# Check ncurses compatibility

# What library to link
ldflags()
{
7 8
	pkg-config --libs ncursesw 2>/dev/null && exit
	pkg-config --libs ncurses 2>/dev/null && exit
9
	for ext in so a dll.a dylib ; do
10 11 12 13 14 15 16 17
		for lib in ncursesw ncurses curses ; do
			$cc -print-file-name=lib${lib}.${ext} | grep -q /
			if [ $? -eq 0 ]; then
				echo "-l${lib}"
				exit
			fi
		done
	done
18
	exit 1
19 20 21 22 23
}

# Where is ncurses.h?
ccflags()
{
24
	if [ -f /usr/include/ncursesw/curses.h ]; then
25
		echo '-I/usr/include/ncursesw -DCURSES_LOC="<curses.h>"'
26
		echo ' -DNCURSES_WIDECHAR=1'
27
	elif [ -f /usr/include/ncurses/ncurses.h ]; then
28 29
		echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"'
	elif [ -f /usr/include/ncurses/curses.h ]; then
30
		echo '-I/usr/include/ncurses -DCURSES_LOC="<curses.h>"'
31 32 33 34 35 36 37
	elif [ -f /usr/include/ncurses.h ]; then
		echo '-DCURSES_LOC="<ncurses.h>"'
	else
		echo '-DCURSES_LOC="<curses.h>"'
	fi
}

S
Sam Ravnborg 已提交
38 39 40 41
# Temp file, try to clean up after us
tmp=.lxdialog.tmp
trap "rm -f $tmp" 0 1 2 3 15

42 43
# Check if we can link to ncurses
check() {
J
Jean Delvare 已提交
44
        $cc -x c - -o $tmp 2>/dev/null <<'EOF'
45 46 47
#include CURSES_LOC
main() {}
EOF
48
	if [ $? != 0 ]; then
49 50 51 52 53 54 55
	    echo " *** Unable to find the ncurses libraries or the"       1>&2
	    echo " *** required header files."                            1>&2
	    echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2
	    echo " *** "                                                  1>&2
	    echo " *** Install ncurses (ncurses-devel) and try again."    1>&2
	    echo " *** "                                                  1>&2
	    exit 1
56 57 58 59
	fi
}

usage() {
60
	printf "Usage: $0 [-check compiler options|-ccflags|-ldflags compiler options]\n"
61 62
}

63
if [ $# -eq 0 ]; then
64 65 66 67
	usage
	exit 1
fi

S
Sam Ravnborg 已提交
68
cc=""
69 70 71
case "$1" in
	"-check")
		shift
72
		cc="$@"
73 74 75 76 77 78
		check
		;;
	"-ccflags")
		ccflags
		;;
	"-ldflags")
79 80
		shift
		cc="$@"
81 82 83 84 85 86 87
		ldflags
		;;
	"*")
		usage
		exit 1
		;;
esac